package body Binary_Search
  with SPARK_Mode
is

   function Search(A: Arr; V: Integer) return Opt_Index is
      L,R,M : Opt_Index;
   begin
      if (A'First > A'Last) then return No_Index; end if;
-      L  := A'First; R := A'Last;
      while L <= R loop
         pragma Loop_Invariant (A'First <= L);
         pragma Loop_Invariant (R <= A'Last);
         pragma Loop_Invariant
            (for all I in A'First .. L - 1 => A(I) < V);
         pragma Loop_Invariant
            (for all I in R + 1 .. A'Last => V < A(I));
         M := L + (R - L) / 2;
         if A(M) < V then L := M + 1;
         elsif A(M) > V then R := M - 1;
         else return M;
         end if;
      end loop;

      return No_Index;
   end Search;

end Binary_Search;
